Package com.macrofocus.utils

# Class IndexedTreeMap<K,V>

java.lang.Object
com.macrofocus.utils.AbstractMap<K,V>
com.macrofocus.utils.IndexedTreeMap<K,V>

Type Parameters:
  `K` - the type of keys maintained by this map
  `V` - the type of mapped values

All Implemented Interfaces:
  `IndexedNavigableMap<K,V>`, `Cloneable`, `Map<K,V>`, `NavigableMap<K,V>`, `SequencedMap<K,V>`, `SortedMap<K,V>`

public class IndexedTreeMap<K,V> extends AbstractMap<K,V> implements IndexedNavigableMap<K,V>, Cloneable
A Red-Black tree based `NavigableMap` implementation. The map is sorted according to the natural ordering of its keys, or by a `Comparator` provided at map creation time, depending on which constructor is used.

This implementation provides guaranteed log(n) time cost for the `containsKey`, `get`, `put` and `remove` operations. Algorithms are adaptations of those in Cormen, Leiserson, and Rivest's Introduction to Algorithms.

Note that the ordering maintained by a sorted map (whether or not an explicit comparator is provided) must be consistent with equals if this sorted map is to correctly implement the `Map` interface. (See `Comparable` or `Comparator` for a precise definition of consistent with equals.) This is so because the `Map` interface is defined in terms of the equals operation, but a map performs all key comparisons using its `compareTo` (or `compare`) method, so two keys that are deemed equal by this method are, from the standpoint of the sorted map, equal. The behavior of a sorted map is well-defined even if its ordering is inconsistent with equals; it just fails to obey the general contract of the `Map` interface.

Note that this implementation is not synchronized. If multiple threads access a map concurrently, and at least one of the threads modifies the map structurally, it must be synchronized externally. (A structural modification is any operation that adds or deletes one or more mappings; merely changing the value associated with an existing key is not a structural modification.) This is typically accomplished by synchronizing on some object that naturally encapsulates the map. If no such object exists, the map should be "wrapped" using the `Collections.synchronizedSortedMap` method. This is best done at creation time, to prevent accidental unsynchronized access to the map:

       SortedMap m = Collections.synchronizedSortedMap(new IndexedTreeMap(...));

The iterators returned by the `iterator` method of the collections returned by all of this class's "collection view methods" are fail-fast: if the map is structurally modified at any time after the iterator is created, in any way except through the iterator's own `remove` method, the iterator will throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that the fail-fast behavior of an iterator cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast iterators throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: the fail-fast behavior of iterators should be used only to detect bugs.

All `Map.Entry` pairs returned by methods in this class and its views represent snapshots of mappings at the time they were produced. They do not support the `Entry.setValue` method. (Note however that it is possible to change mappings in the associated map using `put`.)

This class is a member of the Java Collections Framework.

Since:
  1.2
See Also:
  - `Map`
  - `HashMap`
  - `Hashtable`
  - `Comparable`
  - `Comparator`
  - `Collection`

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class com.macrofocus.utils.AbstractMap

  `AbstractMap.SimpleEntry<K,V>, AbstractMap.SimpleImmutableEntry<K,V>`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `IndexedTreeMap()`
  Constructs a new, empty tree map, using the natural ordering of its keys.
  `IndexedTreeMap(Comparator<? super K> comparator)`
  Constructs a new, empty tree map, ordered according to the given comparator.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Map.Entry<K,V>`
  `ceilingEntry(K key)`
  `K`
  `ceilingKey(K key)`
  `void`
  `clear()`
  Removes all of the mappings from this map.
  `Comparator<? super K>`
  `comparator()`
  `boolean`
  `containsKey(Object key)`
  Returns `true` if this map contains a mapping for the specified key.
  `boolean`
  `containsValue(Object value)`
  Returns `true` if this map maps one or more keys to the specified value.
  `void`
  `dbg()`
  `void`
  `debug()`
  `NavigableSet<K>`
  `descendingKeySet()`
  `NavigableMap<K,V>`
  `descendingMap()`
  `Set<Map.Entry<K,V>>`
  `entrySet()`
  Returns a `Set` view of the mappings contained in this map.
  `com.macrofocus.utils.IndexedTreeMap.Entry<K,V>`
  `exactEntry(int index)`
  Returns a key-value mapping associated with the key located at the index offset from the beginning of the sorted map
  `K`
  `exactKey(int index)`
  Returns the key located at the index offset from the beginning of the sorted map
  `Map.Entry<K,V>`
  `firstEntry()`
  `K`
  `firstKey()`
  `Map.Entry<K,V>`
  `floorEntry(K key)`
  `K`
  `floorKey(K key)`
  `V`
  `get(Object key)`
  Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.
  `SortedMap<K,V>`
  `headMap(K toKey)`
  `NavigableMap<K,V>`
  `headMap(K toKey, boolean inclusive)`
  `Map.Entry<K,V>`
  `higherEntry(K key)`
  `K`
  `higherKey(K key)`
  `int`
  `keyIndex(K key)`
  Searches the specified tree map for the specified key using the put algorithm.
  `Set<K>`
  `keySet()`
  Returns a `Set` view of the keys contained in this map.
  `Map.Entry<K,V>`
  `lastEntry()`
  `K`
  `lastKey()`
  `Map.Entry<K,V>`
  `lowerEntry(K key)`
  `K`
  `lowerKey(K key)`
  `NavigableSet<K>`
  `navigableKeySet()`
  `Map.Entry<K,V>`
  `pollFirstEntry()`
  `Map.Entry<K,V>`
  `pollLastEntry()`
  `V`
  `put(K key, V value)`
  Associates the specified value with the specified key in this map.
  `void`
  `putAll(Map<? extends K,? extends V> map)`
  Copies all of the mappings from the specified map to this map.
  `V`
  `remove(Object key)`
  Removes the mapping for this key from this IndexedTreeMap if present.
  `int`
  `size()`
  Returns the number of key-value mappings in this map.
  `NavigableMap<K,V>`
  `subMap(K fromKey, boolean fromInclusive, K toKey, boolean toInclusive)`
  `SortedMap<K,V>`
  `subMap(K fromKey, K toKey)`
  `SortedMap<K,V>`
  `tailMap(K fromKey)`
  `NavigableMap<K,V>`
  `tailMap(K fromKey, boolean inclusive)`
  `Collection<V>`
  `values()`
  Returns a `Collection` view of the values contained in this map.

  ### Methods inherited from class com.macrofocus.utils.AbstractMap

  `equals, hashCode, isEmpty, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface java.util.Map

  `compute, computeIfAbsent, computeIfPresent, equals, forEach, getOrDefault, hashCode, isEmpty, merge, putIfAbsent, remove, replace, replace, replaceAll`

  ### Methods inherited from interface java.util.NavigableMap

  `reversed`

  ### Methods inherited from interface java.util.SequencedMap

  `sequencedEntrySet, sequencedKeySet, sequencedValues`

  ### Methods inherited from interface java.util.SortedMap

  `putFirst, putLast`

- ## Constructor Details

  - ### IndexedTreeMap

    public IndexedTreeMap()
    Constructs a new, empty tree map, using the natural ordering of its keys. All keys inserted into the map must implement the `Comparable` interface. Furthermore, all such keys must be mutually comparable: `k1.compareTo(k2)` must not throw a `ClassCastException` for any keys `k1` and `k2` in the map. If the user attempts to put a key into the map that violates this constraint (for example, the user attempts to put a string key into a map whose keys are integers), the `put(Object key, Object value)` call will throw a `ClassCastException`.

  - ### IndexedTreeMap

    public IndexedTreeMap(Comparator<? super K> comparator)
    Constructs a new, empty tree map, ordered according to the given comparator. All keys inserted into the map must be mutually comparable by the given comparator: `comparator.compare(k1, k2)` must not throw a `ClassCastException` for any keys `k1` and `k2` in the map. If the user attempts to put a key into the map that violates this constraint, the `put(Object key, Object value)` call will throw a `ClassCastException`.
    Parameters:
      `comparator` - the comparator that will be used to order this map. If `null`, the natural ordering of the keys will be used.

- ## Method Details

  - ### size

    public int size()
    Returns the number of key-value mappings in this map.
    Specified by:
      `size` in interface `Map<K,V>`
    Overrides:
      `size` in class `AbstractMap<K,V>`
    Returns:
      the number of key-value mappings in this map

  - ### containsKey

    public boolean containsKey(Object key)
    Returns `true` if this map contains a mapping for the specified key.
    Specified by:
      `containsKey` in interface `Map<K,V>`
    Overrides:
      `containsKey` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key whose presence in this map is to be tested
    Returns:
      `true` if this map contains a mapping for the specified key
    Throws:
      `ClassCastException` - if the specified key cannot be compared with the keys currently in the map
      `NullPointerException` - if the specified key is null and this map uses natural ordering, or its comparator does not permit null keys

  - ### containsValue

    public boolean containsValue(Object value)
    Returns `true` if this map maps one or more keys to the specified value. More formally, returns `true` if and only if this map contains at least one mapping to a value `v` such that `(value==null ? v==null : value.equals(v))`. This operation will probably require time linear in the map size for most implementations.
    Specified by:
      `containsValue` in interface `Map<K,V>`
    Overrides:
      `containsValue` in class `AbstractMap<K,V>`
    Parameters:
      `value` - value whose presence in this map is to be tested
    Returns:
      `true` if a mapping to `value` exists; `false` otherwise
    Since:
      1.2

  - ### get

    public V get(Object key)
    Returns the value to which the specified key is mapped, or `null` if this map contains no mapping for the key.

    More formally, if this map contains a mapping from a key `k` to a value `v` such that `key` compares equal to `k` according to the map's ordering, then this method returns `v`; otherwise it returns `null`. (There can be at most one such mapping.)

    A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

    Specified by:
      `get` in interface `Map<K,V>`
    Overrides:
      `get` in class `AbstractMap<K,V>`
    Throws:
      `ClassCastException` - if the specified key cannot be compared with the keys currently in the map
      `NullPointerException` - if the specified key is null and this map uses natural ordering, or its comparator does not permit null keys

  - ### comparator

    public Comparator<? super K> comparator()
    Specified by:
      `comparator` in interface `SortedMap<K,V>`

  - ### firstKey

    public K firstKey()
    Specified by:
      `firstKey` in interface `SortedMap<K,V>`

  - ### lastKey

    public K lastKey()
    Specified by:
      `lastKey` in interface `SortedMap<K,V>`

  - ### putAll

    public void putAll(Map<? extends K,? extends V> map)
    Copies all of the mappings from the specified map to this map. These mappings replace any mappings that this map had for any of the keys currently in the specified map.
    Specified by:
      `putAll` in interface `Map<K,V>`
    Overrides:
      `putAll` in class `AbstractMap<K,V>`
    Parameters:
      `map` - mappings to be stored in this map
    Throws:
      `ClassCastException` - if the class of a key or value in the specified map prevents it from being stored in this map
      `NullPointerException` - if the specified map is null or the specified map contains a null key and this map does not permit null keys

  - ### debug

    public void debug() throws Exception
    Throws:
      `Exception`

  - ### dbg

    public void dbg()

  - ### put

    public V put(K key, V value)
    Associates the specified value with the specified key in this map. If the map previously contained a mapping for the key, the old value is replaced.
    Specified by:
      `put` in interface `Map<K,V>`
    Overrides:
      `put` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key with which the specified value is to be associated
      `value` - value to be associated with the specified key
    Returns:
      the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`.)
    Throws:
      `ClassCastException` - if the specified key cannot be compared with the keys currently in the map
      `NullPointerException` - if the specified key is null and this map uses natural ordering, or its comparator does not permit null keys

  - ### remove

    public V remove(Object key)
    Removes the mapping for this key from this IndexedTreeMap if present.
    Specified by:
      `remove` in interface `Map<K,V>`
    Overrides:
      `remove` in class `AbstractMap<K,V>`
    Parameters:
      `key` - key for which mapping should be removed
    Returns:
      the previous value associated with `key`, or `null` if there was no mapping for `key`. (A `null` return can also indicate that the map previously associated `null` with `key`.)
    Throws:
      `ClassCastException` - if the specified key cannot be compared with the keys currently in the map
      `NullPointerException` - if the specified key is null and this map uses natural ordering, or its comparator does not permit null keys

  - ### clear

    public void clear()
    Removes all of the mappings from this map. The map will be empty after this call returns.
    Specified by:
      `clear` in interface `Map<K,V>`
    Overrides:
      `clear` in class `AbstractMap<K,V>`

  - ### firstEntry

    public Map.Entry<K,V> firstEntry()
    Specified by:
      `firstEntry` in interface `NavigableMap<K,V>`
    Specified by:
      `firstEntry` in interface `SequencedMap<K,V>`
    Since:
      1.6

  - ### lastEntry

    public Map.Entry<K,V> lastEntry()
    Specified by:
      `lastEntry` in interface `NavigableMap<K,V>`
    Specified by:
      `lastEntry` in interface `SequencedMap<K,V>`
    Since:
      1.6

  - ### pollFirstEntry

    public Map.Entry<K,V> pollFirstEntry()
    Specified by:
      `pollFirstEntry` in interface `NavigableMap<K,V>`
    Specified by:
      `pollFirstEntry` in interface `SequencedMap<K,V>`
    Since:
      1.6

  - ### pollLastEntry

    public Map.Entry<K,V> pollLastEntry()
    Specified by:
      `pollLastEntry` in interface `NavigableMap<K,V>`
    Specified by:
      `pollLastEntry` in interface `SequencedMap<K,V>`
    Since:
      1.6

  - ### lowerEntry

    public Map.Entry<K,V> lowerEntry(K key)
    Specified by:
      `lowerEntry` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### lowerKey

    public K lowerKey(K key)
    Specified by:
      `lowerKey` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### floorEntry

    public Map.Entry<K,V> floorEntry(K key)
    Specified by:
      `floorEntry` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### floorKey

    public K floorKey(K key)
    Specified by:
      `floorKey` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### ceilingEntry

    public Map.Entry<K,V> ceilingEntry(K key)
    Specified by:
      `ceilingEntry` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### ceilingKey

    public K ceilingKey(K key)
    Specified by:
      `ceilingKey` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### higherEntry

    public Map.Entry<K,V> higherEntry(K key)
    Specified by:
      `higherEntry` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### higherKey

    public K higherKey(K key)
    Specified by:
      `higherKey` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### exactKey

    public K exactKey(int index)
    Description copied from interface: `IndexedNavigableMap`
    Returns the key located at the index offset from the beginning of the sorted map
    Specified by:
      `exactKey` in interface `IndexedNavigableMap<K,V>`
    Parameters:
      `index` - index of the key
    Returns:
      the key `key` located at the index (@code index) offset from the beginning of the sorted map

  - ### keyIndex

    public int keyIndex(K key)
    Description copied from interface: `IndexedNavigableMap`
    Searches the specified tree map for the specified key using the put algorithm. Calculates its offset from the beginning of the sorted map using weights.
    Specified by:
      `keyIndex` in interface `IndexedNavigableMap<K,V>`
    Parameters:
      `key` - the key
    Returns:
      index of the search key, if it is contained in the tree map; otherwise a NullPointerException is thrown

  - ### exactEntry

    public com.macrofocus.utils.IndexedTreeMap.Entry<K,V> exactEntry(int index)
    Description copied from interface: `IndexedNavigableMap`
    Returns a key-value mapping associated with the key located at the index offset from the beginning of the sorted map
    Specified by:
      `exactEntry` in interface `IndexedNavigableMap<K,V>`
    Parameters:
      `index` - index of the key
    Returns:
      the entry with the key `key` located at the index (@code index) offset from the beginning of the sorted map

  - ### keySet

    public Set<K> keySet()
    Returns a `Set` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll`, and `clear` operations. It does not support the `add` or `addAll` operations.
    Specified by:
      `keySet` in interface `Map<K,V>`
    Specified by:
      `keySet` in interface `SortedMap<K,V>`
    Overrides:
      `keySet` in class `AbstractMap<K,V>`

  - ### navigableKeySet

    public NavigableSet<K> navigableKeySet()
    Specified by:
      `navigableKeySet` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### descendingKeySet

    public NavigableSet<K> descendingKeySet()
    Specified by:
      `descendingKeySet` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### values

    public Collection<V> values()
    Returns a `Collection` view of the values contained in this map. The collection's iterator returns the values in ascending order of the corresponding keys. The collection is backed by the map, so changes to the map are reflected in the collection, and vice-versa. If the map is modified while an iteration over the collection is in progress (except through the iterator's own `remove` operation), the results of the iteration are undefined. The collection supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Collection.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
    Specified by:
      `values` in interface `Map<K,V>`
    Specified by:
      `values` in interface `SortedMap<K,V>`
    Overrides:
      `values` in class `AbstractMap<K,V>`

  - ### entrySet

    public Set<Map.Entry<K,V>> entrySet()
    Returns a `Set` view of the mappings contained in this map. The set's iterator returns the entries in ascending key order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own `remove` operation, or through the `setValue` operation on a map entry returned by the iterator) the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the `Iterator.remove`, `Set.remove`, `removeAll`, `retainAll` and `clear` operations. It does not support the `add` or `addAll` operations.
    Specified by:
      `entrySet` in interface `Map<K,V>`
    Specified by:
      `entrySet` in interface `SortedMap<K,V>`
    Specified by:
      `entrySet` in class `AbstractMap<K,V>`

  - ### descendingMap

    public NavigableMap<K,V> descendingMap()
    Specified by:
      `descendingMap` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### subMap

    public NavigableMap<K,V> subMap(K fromKey, boolean fromInclusive, K toKey, boolean toInclusive)
    Specified by:
      `subMap` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### headMap

    public NavigableMap<K,V> headMap(K toKey, boolean inclusive)
    Specified by:
      `headMap` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### tailMap

    public NavigableMap<K,V> tailMap(K fromKey, boolean inclusive)
    Specified by:
      `tailMap` in interface `NavigableMap<K,V>`
    Since:
      1.6

  - ### subMap

    public SortedMap<K,V> subMap(K fromKey, K toKey)
    Specified by:
      `subMap` in interface `NavigableMap<K,V>`
    Specified by:
      `subMap` in interface `SortedMap<K,V>`

  - ### headMap

    public SortedMap<K,V> headMap(K toKey)
    Specified by:
      `headMap` in interface `NavigableMap<K,V>`
    Specified by:
      `headMap` in interface `SortedMap<K,V>`

  - ### tailMap

    public SortedMap<K,V> tailMap(K fromKey)
    Specified by:
      `tailMap` in interface `NavigableMap<K,V>`
    Specified by:
      `tailMap` in interface `SortedMap<K,V>`